# wordpress-plugin-starter
A simple starter for building awesome WordPress plugins

### What it does?
This project is designed to facilitate and speed up the production of WordPress plugins.
It depends on __grunt__ to create a fast and well organized working environment. It's super easy to use and to setup.

---

### Getting started
There are few steps to follow in order to start:
* Download the project to `wp-content/plugins` folder
* Change the **folder name** in order to match your `{your-project}`
* Change `wordpress-plugin-starter.php` to `{your-project}.php`
* Open `{your-project}.php` and change the banner according to your project details
* Open `package.json` and change the according to your project details
+ Run `npm install && npm run start`

Then you are ready to go!

---

### Structure
```
├── assets
│   ├── dist
│   │   ├── css
│   │   └── js
│   └── src
│       ├── js
│       │   ├── admin-script.js
│       │   └── user-script.js
│       └── scss
│           ├── admin-style.scss
│           └── user-style.scss
├── include
│   └── main-class.php
├── languages
│   └── wordpress-plugin-starter.pot
├── Gruntfile.js
├── package.json
├── README.md
└── wordpress-plugin-starter.php

9 directories, 10 files
```

---

### How does it works?
All your plugin related files are located in `assets/src` folder.
While in watch mode all the files in `assets/src` folder and sub-folders will be compiled, uglified and saved in the `assets/dist` folder with the same name of the source file and following the same folder structure.

The plugin textdomain by default is the same that the package name, in this case **wordpress-plugin-starter**.
A `.pot` file named `{package-name}.pot` is automatically generated using _grunt-wp-i18n_ during the watch task or can be manually generated using: `npm run build`.

After every build the pot file containing the translation is updated.

The plugin enqueue jQuery by default, but you can always remove it.

**Note:** remember to change the Text Domain in order to match your package name text domain, we suggest to use the same as the folder name.

---

### Development

Than you can start to write your changes using some npm scripts:

```bash
npm run start     # default task is to watch and rebuild on changes
npm run build     # build task will compile and rebuild everything
```

There are also some grunt task you can run:
```bash
grunt clean:all   # clean the dist folder and the translation pot file
grunt concat      # concat the script files
grunt uglify      # compress and minify the script files
grunt sass        # compile the style files
grunt makepot     # build the translation pot file
```
